> For the complete documentation index, see [llms.txt](https://docs.verygoodsecurity.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.verygoodsecurity.com/enterprise-platform/access-management/manage-users/assigning-roles-to-users/monitoring-user-actions-programmatically.md).

# Monitoring User Actions Programmatically

This page contains a list of sample notifications that will be sent as a result of user management actions. These events can be used by enterprise security teams to monitor any changes in the VGS system. Details on how to configure and consume these notifications can be found in the [Webhook Notifications](/enterprise-platform/developer-resources/webhook-notifications.md) section.

#### User Logged In

```
{
  "description": "User logged in",
  "details": {
    "user_email": "test@test.com",
    "user_ip": "100.151.54.26"
  },
  "event": "user.logged_in",
  "grouping": "every_single",
  "id": "ccd01bb2-e87f-4934-9a72-1367f5131905",
  "integration_id": "INxxxxxxxxR31",
  "occurrence": 1,
  "org_id": "ACxxxxxxxxxxxxxxxxx2399",
  "producer": {
    "user_agent": "",
    "user_email": "test@test.com"
  },
  "scope": "user",
  "summary": "User \"test@test.com\" logged in",
  "tenant": "ACxxxxxxxxxxxxxxxxx2399",
  "timestamp": "2025-10-23T16:31:39.680Z"
}
```

#### User Password Updated

```
{
  "description": "User permissions updated",
  "details": {
    "user_email": "test@test.com",
    "user_ip": "100.151.54.26"
  },
  "event": "user.permissions_updated",
  "grouping": "every_single",
  "id": "ccd01bb2-e87f-4934-9a72-1367f5131905",
  "integration_id": "INxxxxxxxxR31",
  "occurrence": 1,
  "org_id": "ACxxxxxxxxxxxxxxxxx2399",
  "producer": {
    "user_agent": "",
    "user_email": "test@test.com"
  },
  "scope": "user",
  "summary": "User \"test@test.com\" updated permissions",
  "tenant": "ACxxxxxxxxxxxxxxxxx2399",
  "timestamp": "2025-10-23T16:31:39.680Z"
}

```

#### User Password Deleted

```
{
  "description": "User permissions deleted",
  "details": {
    "user_email": "test@test.com",
    "user_ip": "100.151.54.26"
  },
  "event": "user.permissions_deleted",
  "grouping": "every_single",
  "id": "ccd01bb2-e87f-4934-9a72-1367f5131905",
  "integration_id": "INxxxxxxxxR31",
  "occurrence": 1,
  "org_id": "ACxxxxxxxxxxxxxxxxx2399",
  "producer": {
    "user_agent": "",
    "user_email": "test@test.com"
  },
  "scope": "user",
  "summary": "User \"test@test.com\" deleted permissions",
  "tenant": "ACxxxxxxxxxxxxxxxxx2399",
  "timestamp": "2025-10-23T16:31:39.680Z"
}
```

#### User Password Updated

```
{
  "description": "User password updated",
  "details": {
    "user_email": "test@test.com",
    "user_ip": "100.151.54.26"
  },
  "event": "user.password_updated",
  "grouping": "every_single",
  "id": "ccd01bb2-e87f-4934-9a72-1367f5131905",
  "integration_id": "INxxxxxxxxR31",
  "occurrence": 1,
  "org_id": "ACxxxxxxxxxxxxxxxxx2399",
  "producer": {
    "user_agent": "",
    "user_email": "test@test.com"
  },
  "scope": "user",
  "summary": "User \"test@test.com\" updated password",
  "tenant": "ACxxxxxxxxxxxxxxxxx2399",
  "timestamp": "2025-10-23T16:31:39.680Z"
}

```

#### User Enabled MFA

```
{
  "description": "User enabled MFA",
  "details": {
    "user_email": "test@test.com",
    "user_ip": "100.151.54.26"
  },
  "event": "user.mfa_created",
  "grouping": "every_single",
  "id": "ccd01bb2-e87f-4934-9a72-1367f5131905",
  "integration_id": "INxxxxxxxxR31",
  "occurrence": 1,
  "org_id": "ACxxxxxxxxxxxxxxxxx2399",
  "producer": {
    "user_agent": "",
    "user_email": "test@test.com"
  },
  "scope": "user",
  "summary": "User \"test@test.com\" enabled MFA",
  "tenant": "ACxxxxxxxxxxxxxxxxx2399",
  "timestamp": "2025-10-23T16:31:39.680Z"
}
```

#### User Disabled MFA

```
{
  "description": "User disabled MFA",
  "details": {
    "user_email": "test@test.com",
    "user_ip": "100.151.54.26"
  },
  "event": "user.mfa_deleted",
  "grouping": "every_single",
  "id": "ccd01bb2-e87f-4934-9a72-1367f5131905",
  "integration_id": "INxxxxxxxxR31",
  "occurrence": 1,
  "org_id": "ACxxxxxxxxxxxxxxxxx2399",
  "producer": {
    "user_agent": "",
    "user_email": "test@test.com"
  },
  "scope": "user",
  "summary": "User \"test@test.com\" enabled MFA",
  "tenant": "ACxxxxxxxxxxxxxxxxx2399",
  "timestamp": "2025-10-23T16:31:39.680Z"
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.verygoodsecurity.com/enterprise-platform/access-management/manage-users/assigning-roles-to-users/monitoring-user-actions-programmatically.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
